#include <immintrin.h>
#include <omp.h>

#include <vector>
#include <cmath>
#include "CpuGenerators.h"

class CpuGeneratorFloatAVX512 : public mnd::MandelGenerator
{
public:
    CpuGeneratorFloatAVX512(void) :
        MandelGenerator{ mnd::Precision::FLOAT, mnd::X86_AVX_512 }
    {
    }

    virtual void generate(const mnd::MandelInfo& info, float* data) override;
};


extern "C" const std::vector<mnd::MandelGenerator*>& mandel_get_generators(void)
{
    static CpuGeneratorFloatAVX512 instance;
    static std::vector<mnd::MandelGenerator*> vec { &instance };
    return vec;
}


void CpuGeneratorFloatAVX512::generate(const mnd::MandelInfo& info, float* data)
{
}
